const debug=require('debug')('debug');
const db = require('./db');
const helper = require('../helper');

async function get(oset = 1,limit = 100) {
    debug('stops-gtfs-de-not-dhid-oset-limit start...');
    const offset = helper.getOffset(oset, limit);
    const rows = await db.query(
	`SELECT stop_id,stop_name,stop_desc,stop_lat,stop_lon,parent_station,location_type,level_id,platform_code FROM analysis.tbl_stops_gtfs_de_not_dhid OFFSET $1 LIMIT $2;`,
	[offset, limit]
    );
    const data = helper.emptyOrRows(rows);
    debug('stops-gtfs-de-not-dhid-oset-limit done.');
    return data;
};
module.exports = {
  get
};
