import React, { useState, useEffect } from 'react'

import '../style.css';
import Entities from '../components/entities';
import {getStopsCountGtfsDeNotDhid, getStopsCountZhv, getStopsCountGtfs, getStopsCountGtfsDe} from '../utils/api';
export default function Home(){
    const [countStopsGtfs, setCountStopsGtfs] = useState('loading...');
    const [countStopsGtfsDe, setCountStopsGtfsDe] = useState('loading...');
    const [countStopsGtfsDeNotDhid, setCountStopsGtfsDeNotDhid] = useState('loading...');
    const [countStopsZhv, setCountStopsZhv] = useState('loading...');

    /*fetch countStopsGtfs in a JavaScript function*/
    const fetchGtfs = async () => {
        try {
	    let count=await getStopsCountGtfs();
	    setCountStopsGtfs((countStopsGtfs) => count);
        } catch (err) {
            console.error('err.message: ' + err.message);
	    setCountStopsGtfs((countStopsGtfs) => 'loading...');
        }
    };

    /*fetch countStopsGtfsDe in a JavaScript function*/
    const fetchGtfsDe = async () => {
        try {
	    let count=await getStopsCountGtfsDe();
	    setCountStopsGtfsDe((countStopsGtfsDe) => count);
        } catch (err) {
            console.error('err.message: ' + err.message);
	    setCountStopsGtfsDe((countStopsGtfsDe) => 'loading...');
        }
    };

    /*fetch countStopsGtfsDeNotDhid in a JavaScript function*/
    const fetchGtfsDeNotDhid = async () => {
        try {
	    let count=await getStopsCountGtfsDeNotDhid();
	    setCountStopsGtfsDeNotDhid((countStopsGtfsDeNotDhid) => count);
        } catch (err) {
            console.error('err.message: ' + err.message);
	    setCountStopsGtfsDeNotDhid((countStopsGtfsDeNotDhid) => 'loading...');
        }
    };

    /*fetch countStopsZhv in a JavaScript function*/
    const fetchZhv = async () => {
        try {
	    let count=await getStopsCountZhv();
	    setCountStopsZhv((countStopsZhv) => count);
        } catch (err) {
            console.error('err.message: ' + err.message);
	    setCountStopsZhv((countStopsZhv) => 'loading...');
        }
    };

    useEffect(() => {
	/*effect goes here*/
	fetchGtfs();
	fetchGtfsDe();
	fetchGtfsDeNotDhid();
	fetchZhv();
	/*use an empty dependency countStopsGtfs to ensure the hook is running only once*/
	/*TODO study dependency countStopsGtfs: https://reactjs.org/docs/hooks-effect.html*/
    }, []);

    return (
	<>
	    <h1>NAP Display</h1>
	    <h2>
		Wellcome to the German NAP Display!
	    </h2>
	    <p>
		This page compares Global IDs of stops from different NAP sources. <br/>
	    </p>
	    <h3>
		Number of stops of the ZHV: {countStopsZhv}
	    </h3>
	    <h3>
		Number of stops of the DELFI GTFS feed: {countStopsGtfs}
	    </h3>
	    <h3>
		Number of stops of the DELFI GTFS feed inside DE: {countStopsGtfsDe}
	    </h3>
	    <h3>
		Number of stops of the DELFI GTFS feed inside DE not compliant with the Global ID: {countStopsGtfsDeNotDhid}
	    </h3>
	    <p>
		Please feel free to browse through stops of the DELFI GTFS feed inside DE not compliant with the Global ID displayed as Map and Table. <br/>
	    </p>
	    <Entities />
	</>
    );
}
